waxClass{"TwitterViewController", UITableViewController}

function init(self)
	self.super:initWithStyle(UITableViewStyleGrouped)
	self.trends = {}
	
	return self
end

function viewDidLoad(self)
	self:setTitle("My First Wax Application")
	self:tableView():setAllowsSelection(false)

	self:navigationItem():setRightBarButtonItem(UIBarButtonItem:alloc():initWithBarButtonSystemItem_target_action(UIBarButtonSystemItemRefresh, self, "refreshButtonPressed"))
	
	self:loadDataFromTwitter()
end

function loadDataFromTwitter(self)
	UIApplication:sharedApplication():setNetworkActivityIndicatorVisible(true)
	wax.http.request{"http://api.twitter.com/1/trends.json", callback = function(json, response)
		UIApplication:sharedApplication():setNetworkActivityIndicatorVisible(false)
		if response:statusCode() == 200 then
			self.trends = json["trends"]
		end
		self:tableView():reloadData()
	end}
end

function refreshButtonPressed(self)
	self:loadDataFromTwitter()
end

-- DataSource
-------------
function numberOfSectionsInTableView(self, tableView)
	return 1
end

function tableView_numberOfRowsInSection(self, tableView, section)
	return #self.trends
end

function tableView_titleForHeaderInSection(self, tableView, section)
	if section == 0 then
		return "Currently Trending Topics"
	end
	
	return nil
end

function tableView_cellForRowAtIndexPath(self, tableView, indexPath)	
	local identifier = "TwitterTableViewControllerCell"
	local cell = tableView:dequeueReusableCellWithIdentifier(identifier) or
							 UITableViewCell:initWithStyle_reuseIdentifier(UITableViewCellStyleDefault, identifier)	

	local object = self.trends[indexPath:row() + 1] -- Must +1 because lua arrays are 1 based
	cell:textLabel():setText(object["name"])

	return cell
end